clear all;
close all;
clc;


%% runtime tests
N = [2.^(3:10), 2000];

for k = 1:length(N)
  n = N(k)
  A = rand(n);                % Create random n-by-n matrix A
  
  tic
  [L,R,p] = myLuCols(A);      % Calculate LU-Decomposition with myLuCols
  timeLuC(k) = toc
  tic
  [L,R,P] = myLuColsVec(A);   % Calculate LU-Decomposition with myLuColsVec
  timeLuCV(k) = toc  
  tic
  [L,R,P] = myLuRows(A);      % Calculate LU-Decomposition with myLuRows
  timeLuR(k) = toc
  tic
  [L,R,P] = myLuRowsVec(A);   % Calculate LU-Decomposition with myLuRowsVec  
  timeLuRV(k) = toc
end

%% plot result

figure(1)
loglog(N,timeLuC  ,'ro-')
hold on
loglog(N,timeLuCV ,'ko--')
loglog(N,timeLuR  ,'g*-')
loglog(N,timeLuRV ,'b*--')
hold off
legend('myLuCols','myLuColsVec',...
       'myLuRows','myLuRowsVec','Location','NorthWest')
loglogTriangle(15,200,0.005 ,-2.1,'l')
loglogTriangle(70,900,0.003,-3,'u')
xlim([4,5000])
xlabel('N')
ylabel('time in seconds')
title('Computation times for the LU-decomposition')